# NAME

DiscoverSnoop

API for DiscoverSnoop Service

# VERSION

Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.9.240913
- Package version: 
- Build package: io.swagger.codegen.v3.generators.scala.ScalaClientCodegen

# Requirements

Building the API client library requires [Maven](https://maven.apache.org/) to be installed.

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn deploy
```

Refer to the [official documentation](https://maven.apache.org/plugins/maven-deploy-plugin/usage.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
    <groupId>io.swagger</groupId>
    <artifactId>swagger-scala-client</artifactId>
    <version>1.0.0</version>
    <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-scala-client:1.0.0"
```

### SBT users

```scala
libraryDependencies += "io.swagger" % "swagger-scala-client" % "1.0.0"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AlertsApi* | [**alertsChangeGet**](AlertsApi.md#alertsChangeGet) | **GET** /alerts_change | Edit or insert new alert
*AlertsApi* | [**alertsDeleteGet**](AlertsApi.md#alertsDeleteGet) | **GET** /alerts_delete | Permanently delete the alert
*AlertsApi* | [**alertsGet**](AlertsApi.md#alertsGet) | **GET** /alerts | Get alerts for user account
*FavsApi* | [**favsAddGet**](FavsApi.md#favsAddGet) | **GET** /favs_add | Create a new fav
*FavsApi* | [**favsDeleteGet**](FavsApi.md#favsDeleteGet) | **GET** /favs_delete | Permanently delete the fav
*FavsApi* | [**favsGet**](FavsApi.md#favsGet) | **GET** /favs | Get favorites
*FavsApi* | [**favsUpdateGet**](FavsApi.md#favsUpdateGet) | **GET** /favs_update | Update the fav
*HistoricalApi* | [**categoriesGet**](HistoricalApi.md#categoriesGet) | **GET** /categories | Get historical stats for categories
*HistoricalApi* | [**categoryGet**](HistoricalApi.md#categoryGet) | **GET** /category | Get history for category ID
*HistoricalApi* | [**domainGet**](HistoricalApi.md#domainGet) | **GET** /domain | Get history for domain name
*HistoricalApi* | [**domainsGet**](HistoricalApi.md#domainsGet) | **GET** /domains | Get historical stats for domains
*HistoricalApi* | [**pageGet**](HistoricalApi.md#pageGet) | **GET** /page | Get page history for URL
*HistoricalApi* | [**pagesGet**](HistoricalApi.md#pagesGet) | **GET** /pages | Get historical stats for pages
*KbApi* | [**kbArticlesGet**](KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles
*LiveApi* | [**livecategoriesGet**](LiveApi.md#livecategoriesGet) | **GET** /livecategories | Get livedata stats for categories
*LiveApi* | [**livedomainsGet**](LiveApi.md#livedomainsGet) | **GET** /livedomains | Get livedata stats for domains
*LiveApi* | [**livepagesGet**](LiveApi.md#livepagesGet) | **GET** /livepages | Get livedata stats for pages
*UserApi* | [**userCountriesChangeGet**](UserApi.md#userCountriesChangeGet) | **GET** /user_countries_change | Change user&#x27;s activated countries
*UserApi* | [**userCustidChangeGet**](UserApi.md#userCustidChangeGet) | **GET** /user_custid_change | Change user customer id. This function is system reserved
*UserApi* | [**userDeleteGet**](UserApi.md#userDeleteGet) | **GET** /user_delete | Permanently delete the user
*UserApi* | [**userDetailsChangeGet**](UserApi.md#userDetailsChangeGet) | **GET** /user_details_change | Change user details
*UserApi* | [**userLoginGet**](UserApi.md#userLoginGet) | **GET** /user_login | Login user with his credentials
*UserApi* | [**userMessagesGet**](UserApi.md#userMessagesGet) | **GET** /user_messages | Get messages for user
*UserApi* | [**userPasswordChangeGet**](UserApi.md#userPasswordChangeGet) | **GET** /user_password_change | Change user password
*UserApi* | [**userPasswordResetGet**](UserApi.md#userPasswordResetGet) | **GET** /user_password_reset | Reset user password
*UserApi* | [**userRefreshSubscriptionGet**](UserApi.md#userRefreshSubscriptionGet) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*UserApi* | [**userRegisterGet**](UserApi.md#userRegisterGet) | **GET** /user_register | Login user with his credentials

## Documentation for Models

 - [AlertCollection](AlertCollection.md)
 - [Alerts](Alerts.md)
 - [Categories](Categories.md)
 - [CategoriesCollection](CategoriesCollection.md)
 - [Category](Category.md)
 - [DistributionCollection](DistributionCollection.md)
 - [Domain](Domain.md)
 - [Domains](Domains.md)
 - [DomainsCollection](DomainsCollection.md)
 - [Favs](Favs.md)
 - [FavsCollection](FavsCollection.md)
 - [HistoryCollection](HistoryCollection.md)
 - [KB](KB.md)
 - [KBCollection](KBCollection.md)
 - [Message](Message.md)
 - [MessageCollection](MessageCollection.md)
 - [MetricsCollection](MetricsCollection.md)
 - [Page](Page.md)
 - [Pages](Pages.md)
 - [PagesCollection](PagesCollection.md)
 - [TransactionInfo](TransactionInfo.md)
 - [UserCollection](UserCollection.md)
 - [UserInfo](UserInfo.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### bearerAuth




# BUILDING YOUR LIBRARY

See the homepage `https://github.com/swagger-api/swagger-codegen` for full details.
But briefly, clone the git repository, build the codegen codebase, set up your build
config file, then run the API build script. You will need git, Java 7 or 8 and Apache
maven 3.0.3 or better already installed.

Your library files will be built under `WWW::MyProjectName`.

          $ git clone https://github.com/swagger-api/swagger-codegen.git
          $ cd swagger-codegen
          $ mvn package
          $ java -jar modules/swagger-codegen-cli/target/swagger-codegen-cli.jar generate \
    -i [URL or file path to JSON swagger API spec] \
    -l akka-scala \
    -c /path/to/config/file.json \
    -o /path/to/output/folder

Bang, all done. Run the `autodoc` script in the `bin` directory to see the API
you just built.

## Author


