/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.api

import java.text.SimpleDateFormat

import io.swagger.client.model.Alerts
import io.swagger.client.model.Domains
import io.swagger.client.model.TransactionInfo
import io.swagger.client.{ApiInvoker, ApiException}

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date
import java.util.TimeZone

import scala.collection.mutable.HashMap

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

import java.net.URI

import com.wordnik.swagger.client.ClientResponseReaders.Json4sFormatsReader._
import com.wordnik.swagger.client.RequestWriters.Json4sFormatsWriter._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import scala.concurrent.duration._
import scala.util.{Failure, Success, Try}

import org.json4s._

class AlertsApi(
  val defBasePath: String = "https://api.discoversnoop.com",
  defApiInvoker: ApiInvoker = ApiInvoker
) {
  private lazy val dateTimeFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  private val dateFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  implicit val formats = new org.json4s.DefaultFormats {
    override def dateFormatter = dateTimeFormatter
  }
  implicit val stringReader: ClientResponseReader[String] = ClientResponseReaders.StringReader
  implicit val unitReader: ClientResponseReader[Unit] = ClientResponseReaders.UnitReader
  implicit val jvalueReader: ClientResponseReader[JValue] = ClientResponseReaders.JValueReader
  implicit val jsonReader: ClientResponseReader[Nothing] = JsonFormatsReader
  implicit val stringWriter: RequestWriter[String] = RequestWriters.StringWriter
  implicit val jsonWriter: RequestWriter[Nothing] = JsonFormatsWriter

  var basePath: String = defBasePath
  var apiInvoker: ApiInvoker = defApiInvoker

  def addHeader(key: String, value: String): mutable.HashMap[String, String] = {
    apiInvoker.defaultHeaders += key -> value
  }

  val config: SwaggerConfig = SwaggerConfig.forUrl(new URI(defBasePath))
  val client = new RestClient(config)
  val helper = new AlertsApiAsyncHelper(client, config)

  /**
   * Edit or insert new alert
   * 
   *
   * @param id ID of the alert to edit ; if adding a new one leave blank 
   * @param alertname Name of the alert 
   * @param activated Should the alert be activated or not 
   * @param &#x60;type&#x60; Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) 
   * @param channel 1 for email, 2 for Slack, 3 for Google Chat 
   * @param recipient Email address of recipient or webhook for Slack/Gchat 
   * @param param1 Parameter 1 (meaning changes with alert type) (optional)
   * @param param2 Parameter 2 (meaning changes with alert type) (optional)
   * @param param3 Parameter 3 (meaning changes with alert type) (optional)
   * @param param4 Parameter 4 (meaning changes with alert type) (optional)
   * @param param5 Parameter 5 (meaning changes with alert type) (optional)
   * @return List[Domains]
   */
  def alertsChangeGet(id: String, alertname: String, activated: Boolean, &#x60;type&#x60;: Integer, channel: Integer, recipient: String, param1: Option[String] = None, param2: Option[String] = None, param3: Option[String] = None, param4: Option[String] = None, param5: Option[String] = None): Option[List[Domains]] = {
    val await = Try(Await.result(alertsChangeGetAsync(id, alertname, activated, &#x60;type&#x60;, channel, recipient, param1, param2, param3, param4, param5), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Edit or insert new alert asynchronously
   * 
   *
   * @param id ID of the alert to edit ; if adding a new one leave blank 
   * @param alertname Name of the alert 
   * @param activated Should the alert be activated or not 
   * @param &#x60;type&#x60; Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) 
   * @param channel 1 for email, 2 for Slack, 3 for Google Chat 
   * @param recipient Email address of recipient or webhook for Slack/Gchat 
   * @param param1 Parameter 1 (meaning changes with alert type) (optional)
   * @param param2 Parameter 2 (meaning changes with alert type) (optional)
   * @param param3 Parameter 3 (meaning changes with alert type) (optional)
   * @param param4 Parameter 4 (meaning changes with alert type) (optional)
   * @param param5 Parameter 5 (meaning changes with alert type) (optional)
   * @return Future(List[Domains])
   */
  def alertsChangeGetAsync(id: String, alertname: String, activated: Boolean, &#x60;type&#x60;: Integer, channel: Integer, recipient: String, param1: Option[String] = None, param2: Option[String] = None, param3: Option[String] = None, param4: Option[String] = None, param5: Option[String] = None): Future[List[Domains]] = {
      helper.alertsChangeGet(id, alertname, activated, &#x60;type&#x60;, channel, recipient, param1, param2, param3, param4, param5)
  }

  /**
   * Permanently delete the alert
   * 
   *
   * @param id alert id to delete 
   * @return List[TransactionInfo]
   */
  def alertsDeleteGet(id: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(alertsDeleteGetAsync(id), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Permanently delete the alert asynchronously
   * 
   *
   * @param id alert id to delete 
   * @return Future(List[TransactionInfo])
   */
  def alertsDeleteGetAsync(id: String): Future[List[TransactionInfo]] = {
      helper.alertsDeleteGet(id)
  }

  /**
   * Get alerts for user account
   * 
   *
   * @return List[Alerts]
   */
  def alertsGet(): Option[List[Alerts]] = {
    val await = Try(Await.result(alertsGetAsync(), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get alerts for user account asynchronously
   * 
   *
   * @return Future(List[Alerts])
   */
  def alertsGetAsync(): Future[List[Alerts]] = {
      helper.alertsGet()
  }

}

class AlertsApiAsyncHelper(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def alertsChangeGet(id: String,
    alertname: String,
    activated: Boolean,
    &#x60;type&#x60;: Integer,
    channel: Integer,
    recipient: String,
    param1: Option[String] = None,
    param2: Option[String] = None,
    param3: Option[String] = None,
    param4: Option[String] = None,
    param5: Option[String] = None
    )(implicit reader: ClientResponseReader[List[Domains]]): Future[List[Domains]] = {
    // create path and map variables
    val path = (addFmt("/alerts_change"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (id == null) throw new Exception("Missing required parameter 'id' when calling AlertsApi->alertsChangeGet")

    if (alertname == null) throw new Exception("Missing required parameter 'alertname' when calling AlertsApi->alertsChangeGet")

    if (recipient == null) throw new Exception("Missing required parameter 'recipient' when calling AlertsApi->alertsChangeGet")

    queryParams += "id" -> id.toString
    queryParams += "alertname" -> alertname.toString
    queryParams += "activated" -> activated.toString
    queryParams += "type" -> &#x60;type&#x60;.toString
    queryParams += "channel" -> channel.toString
    queryParams += "recipient" -> recipient.toString
    param1 match {
      case Some(param) => queryParams += "param1" -> param.toString
      case _ => queryParams
    }
    param2 match {
      case Some(param) => queryParams += "param2" -> param.toString
      case _ => queryParams
    }
    param3 match {
      case Some(param) => queryParams += "param3" -> param.toString
      case _ => queryParams
    }
    param4 match {
      case Some(param) => queryParams += "param4" -> param.toString
      case _ => queryParams
    }
    param5 match {
      case Some(param) => queryParams += "param5" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def alertsDeleteGet(id: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/alerts_delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (id == null) throw new Exception("Missing required parameter 'id' when calling AlertsApi->alertsDeleteGet")

    queryParams += "id" -> id.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def alertsGet()(implicit reader: ClientResponseReader[List[Alerts]]): Future[List[Alerts]] = {
    // create path and map variables
    val path = (addFmt("/alerts"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]


    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
