/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.api

import java.text.SimpleDateFormat

import io.swagger.client.model.Favs
import io.swagger.client.model.TransactionInfo
import io.swagger.client.{ApiInvoker, ApiException}

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date
import java.util.TimeZone

import scala.collection.mutable.HashMap

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

import java.net.URI

import com.wordnik.swagger.client.ClientResponseReaders.Json4sFormatsReader._
import com.wordnik.swagger.client.RequestWriters.Json4sFormatsWriter._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import scala.concurrent.duration._
import scala.util.{Failure, Success, Try}

import org.json4s._

class FavsApi(
  val defBasePath: String = "https://api.discoversnoop.com",
  defApiInvoker: ApiInvoker = ApiInvoker
) {
  private lazy val dateTimeFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  private val dateFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  implicit val formats = new org.json4s.DefaultFormats {
    override def dateFormatter = dateTimeFormatter
  }
  implicit val stringReader: ClientResponseReader[String] = ClientResponseReaders.StringReader
  implicit val unitReader: ClientResponseReader[Unit] = ClientResponseReaders.UnitReader
  implicit val jvalueReader: ClientResponseReader[JValue] = ClientResponseReaders.JValueReader
  implicit val jsonReader: ClientResponseReader[Nothing] = JsonFormatsReader
  implicit val stringWriter: RequestWriter[String] = RequestWriters.StringWriter
  implicit val jsonWriter: RequestWriter[Nothing] = JsonFormatsWriter

  var basePath: String = defBasePath
  var apiInvoker: ApiInvoker = defApiInvoker

  def addHeader(key: String, value: String): mutable.HashMap[String, String] = {
    apiInvoker.defaultHeaders += key -> value
  }

  val config: SwaggerConfig = SwaggerConfig.forUrl(new URI(defBasePath))
  val client = new RestClient(config)
  val helper = new FavsApiAsyncHelper(client, config)

  /**
   * Create a new fav
   * 
   *
   * @param name Name of the fav. (optional)
   * @param action Action to be opened. (optional)
   * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
   * @return List[TransactionInfo]
   */
  def favsAddGet(name: Option[String] = None, action: Option[String] = None, parameters: Option[String] = None): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(favsAddGetAsync(name, action, parameters), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Create a new fav asynchronously
   * 
   *
   * @param name Name of the fav. (optional)
   * @param action Action to be opened. (optional)
   * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
   * @return Future(List[TransactionInfo])
   */
  def favsAddGetAsync(name: Option[String] = None, action: Option[String] = None, parameters: Option[String] = None): Future[List[TransactionInfo]] = {
      helper.favsAddGet(name, action, parameters)
  }

  /**
   * Permanently delete the fav
   * 
   *
   * @param id ID of the fav to delete. (optional)
   * @return List[TransactionInfo]
   */
  def favsDeleteGet(id: Option[String] = None): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(favsDeleteGetAsync(id), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Permanently delete the fav asynchronously
   * 
   *
   * @param id ID of the fav to delete. (optional)
   * @return Future(List[TransactionInfo])
   */
  def favsDeleteGetAsync(id: Option[String] = None): Future[List[TransactionInfo]] = {
      helper.favsDeleteGet(id)
  }

  /**
   * Get favorites
   * 
   *
   * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
   * @return List[Favs]
   */
  def favsGet(id: Option[String] = None): Option[List[Favs]] = {
    val await = Try(Await.result(favsGetAsync(id), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get favorites asynchronously
   * 
   *
   * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
   * @return Future(List[Favs])
   */
  def favsGetAsync(id: Option[String] = None): Future[List[Favs]] = {
      helper.favsGet(id)
  }

  /**
   * Update the fav
   * 
   *
   * @param id ID of the fav that should be edited 
   * @param name Name of the fav. (optional)
   * @param action Action to be opened. (optional)
   * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
   * @param scheduled 0 if not scheduled, else x in hours (optional)
   * @param scheduledto email address of the recipient of this report (optional)
   * @return List[TransactionInfo]
   */
  def favsUpdateGet(id: String, name: Option[String] = None, action: Option[String] = None, parameters: Option[String] = None, scheduled: Option[Integer] = None, scheduledto: Option[String] = None): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(favsUpdateGetAsync(id, name, action, parameters, scheduled, scheduledto), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Update the fav asynchronously
   * 
   *
   * @param id ID of the fav that should be edited 
   * @param name Name of the fav. (optional)
   * @param action Action to be opened. (optional)
   * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
   * @param scheduled 0 if not scheduled, else x in hours (optional)
   * @param scheduledto email address of the recipient of this report (optional)
   * @return Future(List[TransactionInfo])
   */
  def favsUpdateGetAsync(id: String, name: Option[String] = None, action: Option[String] = None, parameters: Option[String] = None, scheduled: Option[Integer] = None, scheduledto: Option[String] = None): Future[List[TransactionInfo]] = {
      helper.favsUpdateGet(id, name, action, parameters, scheduled, scheduledto)
  }

}

class FavsApiAsyncHelper(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def favsAddGet(name: Option[String] = None,
    action: Option[String] = None,
    parameters: Option[String] = None
    )(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/favs_add"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    name match {
      case Some(param) => queryParams += "name" -> param.toString
      case _ => queryParams
    }
    action match {
      case Some(param) => queryParams += "action" -> param.toString
      case _ => queryParams
    }
    parameters match {
      case Some(param) => queryParams += "parameters" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def favsDeleteGet(id: Option[String] = None
    )(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/favs_delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    id match {
      case Some(param) => queryParams += "id" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def favsGet(id: Option[String] = None
    )(implicit reader: ClientResponseReader[List[Favs]]): Future[List[Favs]] = {
    // create path and map variables
    val path = (addFmt("/favs"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    id match {
      case Some(param) => queryParams += "id" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def favsUpdateGet(id: String,
    name: Option[String] = None,
    action: Option[String] = None,
    parameters: Option[String] = None,
    scheduled: Option[Integer] = None,
    scheduledto: Option[String] = None
    )(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/favs_update"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (id == null) throw new Exception("Missing required parameter 'id' when calling FavsApi->favsUpdateGet")

    queryParams += "id" -> id.toString
    name match {
      case Some(param) => queryParams += "name" -> param.toString
      case _ => queryParams
    }
    action match {
      case Some(param) => queryParams += "action" -> param.toString
      case _ => queryParams
    }
    parameters match {
      case Some(param) => queryParams += "parameters" -> param.toString
      case _ => queryParams
    }
    scheduled match {
      case Some(param) => queryParams += "scheduled" -> param.toString
      case _ => queryParams
    }
    scheduledto match {
      case Some(param) => queryParams += "scheduledto" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
