/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.api

import java.text.SimpleDateFormat

import io.swagger.client.model.Categories
import io.swagger.client.model.Category
import io.swagger.client.model.Domain
import io.swagger.client.model.Domains
import io.swagger.client.model.Page
import io.swagger.client.model.Pages
import io.swagger.client.{ApiInvoker, ApiException}

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date
import java.util.TimeZone

import scala.collection.mutable.HashMap

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

import java.net.URI

import com.wordnik.swagger.client.ClientResponseReaders.Json4sFormatsReader._
import com.wordnik.swagger.client.RequestWriters.Json4sFormatsWriter._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import scala.concurrent.duration._
import scala.util.{Failure, Success, Try}

import org.json4s._

class HistoricalApi(
  val defBasePath: String = "https://api.discoversnoop.com",
  defApiInvoker: ApiInvoker = ApiInvoker
) {
  private lazy val dateTimeFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  private val dateFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  implicit val formats = new org.json4s.DefaultFormats {
    override def dateFormatter = dateTimeFormatter
  }
  implicit val stringReader: ClientResponseReader[String] = ClientResponseReaders.StringReader
  implicit val unitReader: ClientResponseReader[Unit] = ClientResponseReaders.UnitReader
  implicit val jvalueReader: ClientResponseReader[JValue] = ClientResponseReaders.JValueReader
  implicit val jsonReader: ClientResponseReader[Nothing] = JsonFormatsReader
  implicit val stringWriter: RequestWriter[String] = RequestWriters.StringWriter
  implicit val jsonWriter: RequestWriter[Nothing] = JsonFormatsWriter

  var basePath: String = defBasePath
  var apiInvoker: ApiInvoker = defApiInvoker

  def addHeader(key: String, value: String): mutable.HashMap[String, String] = {
    apiInvoker.defaultHeaders += key -> value
  }

  val config: SwaggerConfig = SwaggerConfig.forUrl(new URI(defBasePath))
  val client = new RestClient(config)
  val helper = new HistoricalApiAsyncHelper(client, config)

  /**
   * Get historical stats for categories
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Categories]
   */
  def categoriesGet(country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None, keywordFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Option[List[Categories]] = {
    val await = Try(Await.result(categoriesGetAsync(country, subcountry, fromDate, toDate, keywordFilter, lines, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get historical stats for categories asynchronously
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Categories])
   */
  def categoriesGetAsync(country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None, keywordFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Future[List[Categories]] = {
      helper.categoriesGet(country, subcountry, fromDate, toDate, keywordFilter, lines, offset)
  }

  /**
   * Get history for category ID
   * 
   *
   * @param id category id 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return List[Category]
   */
  def categoryGet(id: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Option[List[Category]] = {
    val await = Try(Await.result(categoryGetAsync(id, country, subcountry, fromDate, toDate), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get history for category ID asynchronously
   * 
   *
   * @param id category id 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return Future(List[Category])
   */
  def categoryGetAsync(id: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Future[List[Category]] = {
      helper.categoryGet(id, country, subcountry, fromDate, toDate)
  }

  /**
   * Get history for domain name
   * 
   *
   * @param domain domain name (no subdomain allowed) 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return List[Domain]
   */
  def domainGet(domain: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Option[List[Domain]] = {
    val await = Try(Await.result(domainGetAsync(domain, country, subcountry, fromDate, toDate), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get history for domain name asynchronously
   * 
   *
   * @param domain domain name (no subdomain allowed) 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return Future(List[Domain])
   */
  def domainGetAsync(domain: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Future[List[Domain]] = {
      helper.domainGet(domain, country, subcountry, fromDate, toDate)
  }

  /**
   * Get historical stats for domains
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param urlFilter Filter answers to domains including a specified string (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Domains]
   */
  def domainsGet(country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None, urlFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Option[List[Domains]] = {
    val await = Try(Await.result(domainsGetAsync(country, subcountry, fromDate, toDate, urlFilter, lines, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get historical stats for domains asynchronously
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param urlFilter Filter answers to domains including a specified string (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Domains])
   */
  def domainsGetAsync(country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None, urlFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Future[List[Domains]] = {
      helper.domainsGet(country, subcountry, fromDate, toDate, urlFilter, lines, offset)
  }

  /**
   * Get page history for URL
   * 
   *
   * @param url Fully qualified page url. URL needs to be URL encoded 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return List[Page]
   */
  def pageGet(url: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Option[List[Page]] = {
    val await = Try(Await.result(pageGetAsync(url, country, subcountry, fromDate, toDate), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get page history for URL asynchronously
   * 
   *
   * @param url Fully qualified page url. URL needs to be URL encoded 
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
   * @return Future(List[Page])
   */
  def pageGetAsync(url: String, country: String, subcountry: Option[String] = None, fromDate: Option[String] = None, toDate: Option[String] = None): Future[List[Page]] = {
      helper.pageGet(url, country, subcountry, fromDate, toDate)
  }

  /**
   * Get historical stats for pages
   * 
   *
   * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
   * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
   * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
   * @param subcountry state code (optional)
   * @param domainFilter Filter answers to pages of a designated domain name (optional)
   * @param urlFilter Filter answers to pages URL including a specified string (optional)
   * @param categoryFilter Filter answers to a specific page category (optional)
   * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
   * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Pages]
   */
  def pagesGet(presetFilter: Integer, fromDate: Option[String] = None, toDate: Option[String] = None, country: Option[String] = None, subcountry: Option[String] = None, domainFilter: Option[String] = None, urlFilter: Option[String] = None, categoryFilter: Option[Integer] = None, keywordFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Option[List[Pages]] = {
    val await = Try(Await.result(pagesGetAsync(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get historical stats for pages asynchronously
   * 
   *
   * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
   * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
   * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
   * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
   * @param subcountry state code (optional)
   * @param domainFilter Filter answers to pages of a designated domain name (optional)
   * @param urlFilter Filter answers to pages URL including a specified string (optional)
   * @param categoryFilter Filter answers to a specific page category (optional)
   * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
   * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Pages])
   */
  def pagesGetAsync(presetFilter: Integer, fromDate: Option[String] = None, toDate: Option[String] = None, country: Option[String] = None, subcountry: Option[String] = None, domainFilter: Option[String] = None, urlFilter: Option[String] = None, categoryFilter: Option[Integer] = None, keywordFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Future[List[Pages]] = {
      helper.pagesGet(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset)
  }

}

class HistoricalApiAsyncHelper(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def categoriesGet(country: String,
    subcountry: Option[String] = None,
    fromDate: Option[String] = None,
    toDate: Option[String] = None,
    keywordFilter: Option[String] = None,
    lines: Option[Integer] = Option(50),
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Categories]]): Future[List[Categories]] = {
    // create path and map variables
    val path = (addFmt("/categories"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (country == null) throw new Exception("Missing required parameter 'country' when calling HistoricalApi->categoriesGet")

    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }
    keywordFilter match {
      case Some(param) => queryParams += "keyword_filter" -> param.toString
      case _ => queryParams
    }
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def categoryGet(id: String,
    country: String,
    subcountry: Option[String] = None,
    fromDate: Option[String] = None,
    toDate: Option[String] = None
    )(implicit reader: ClientResponseReader[List[Category]]): Future[List[Category]] = {
    // create path and map variables
    val path = (addFmt("/category"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (id == null) throw new Exception("Missing required parameter 'id' when calling HistoricalApi->categoryGet")

    if (country == null) throw new Exception("Missing required parameter 'country' when calling HistoricalApi->categoryGet")

    queryParams += "id" -> id.toString
    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def domainGet(domain: String,
    country: String,
    subcountry: Option[String] = None,
    fromDate: Option[String] = None,
    toDate: Option[String] = None
    )(implicit reader: ClientResponseReader[List[Domain]]): Future[List[Domain]] = {
    // create path and map variables
    val path = (addFmt("/domain"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (domain == null) throw new Exception("Missing required parameter 'domain' when calling HistoricalApi->domainGet")

    if (country == null) throw new Exception("Missing required parameter 'country' when calling HistoricalApi->domainGet")

    queryParams += "domain" -> domain.toString
    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def domainsGet(country: String,
    subcountry: Option[String] = None,
    fromDate: Option[String] = None,
    toDate: Option[String] = None,
    urlFilter: Option[String] = None,
    lines: Option[Integer] = Option(50),
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Domains]]): Future[List[Domains]] = {
    // create path and map variables
    val path = (addFmt("/domains"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (country == null) throw new Exception("Missing required parameter 'country' when calling HistoricalApi->domainsGet")

    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }
    urlFilter match {
      case Some(param) => queryParams += "url_filter" -> param.toString
      case _ => queryParams
    }
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def pageGet(url: String,
    country: String,
    subcountry: Option[String] = None,
    fromDate: Option[String] = None,
    toDate: Option[String] = None
    )(implicit reader: ClientResponseReader[List[Page]]): Future[List[Page]] = {
    // create path and map variables
    val path = (addFmt("/page"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (url == null) throw new Exception("Missing required parameter 'url' when calling HistoricalApi->pageGet")

    if (country == null) throw new Exception("Missing required parameter 'country' when calling HistoricalApi->pageGet")

    queryParams += "url" -> url.toString
    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def pagesGet(presetFilter: Integer,
    fromDate: Option[String] = None,
    toDate: Option[String] = None,
    country: Option[String] = None,
    subcountry: Option[String] = None,
    domainFilter: Option[String] = None,
    urlFilter: Option[String] = None,
    categoryFilter: Option[Integer] = None,
    keywordFilter: Option[String] = None,
    lines: Option[Integer] = Option(50),
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Pages]]): Future[List[Pages]] = {
    // create path and map variables
    val path = (addFmt("/pages"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    fromDate match {
      case Some(param) => queryParams += "from_date" -> param.toString
      case _ => queryParams
    }
    toDate match {
      case Some(param) => queryParams += "to_date" -> param.toString
      case _ => queryParams
    }
    country match {
      case Some(param) => queryParams += "country" -> param.toString
      case _ => queryParams
    }
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    domainFilter match {
      case Some(param) => queryParams += "domain_filter" -> param.toString
      case _ => queryParams
    }
    urlFilter match {
      case Some(param) => queryParams += "url_filter" -> param.toString
      case _ => queryParams
    }
    categoryFilter match {
      case Some(param) => queryParams += "category_filter" -> param.toString
      case _ => queryParams
    }
    keywordFilter match {
      case Some(param) => queryParams += "keyword_filter" -> param.toString
      case _ => queryParams
    }
    queryParams += "preset_filter" -> presetFilter.toString
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
