/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.api

import java.text.SimpleDateFormat

import io.swagger.client.model.Categories
import io.swagger.client.model.Domains
import io.swagger.client.model.Pages
import io.swagger.client.{ApiInvoker, ApiException}

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date
import java.util.TimeZone

import scala.collection.mutable.HashMap

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

import java.net.URI

import com.wordnik.swagger.client.ClientResponseReaders.Json4sFormatsReader._
import com.wordnik.swagger.client.RequestWriters.Json4sFormatsWriter._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import scala.concurrent.duration._
import scala.util.{Failure, Success, Try}

import org.json4s._

class LiveApi(
  val defBasePath: String = "https://api.discoversnoop.com",
  defApiInvoker: ApiInvoker = ApiInvoker
) {
  private lazy val dateTimeFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  private val dateFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  implicit val formats = new org.json4s.DefaultFormats {
    override def dateFormatter = dateTimeFormatter
  }
  implicit val stringReader: ClientResponseReader[String] = ClientResponseReaders.StringReader
  implicit val unitReader: ClientResponseReader[Unit] = ClientResponseReaders.UnitReader
  implicit val jvalueReader: ClientResponseReader[JValue] = ClientResponseReaders.JValueReader
  implicit val jsonReader: ClientResponseReader[Nothing] = JsonFormatsReader
  implicit val stringWriter: RequestWriter[String] = RequestWriters.StringWriter
  implicit val jsonWriter: RequestWriter[Nothing] = JsonFormatsWriter

  var basePath: String = defBasePath
  var apiInvoker: ApiInvoker = defApiInvoker

  def addHeader(key: String, value: String): mutable.HashMap[String, String] = {
    apiInvoker.defaultHeaders += key -> value
  }

  val config: SwaggerConfig = SwaggerConfig.forUrl(new URI(defBasePath))
  val client = new RestClient(config)
  val helper = new LiveApiAsyncHelper(client, config)

  /**
   * Get livedata stats for categories
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param hours Get results for last x hours (optional)
   * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Categories]
   */
  def livecategoriesGet(country: String, subcountry: Option[String] = None, hours: Option[Integer] = None, keywordFilter: Option[String] = None, languageFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Option[List[Categories]] = {
    val await = Try(Await.result(livecategoriesGetAsync(country, subcountry, hours, keywordFilter, languageFilter, lines, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get livedata stats for categories asynchronously
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param hours Get results for last x hours (optional)
   * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Categories])
   */
  def livecategoriesGetAsync(country: String, subcountry: Option[String] = None, hours: Option[Integer] = None, keywordFilter: Option[String] = None, languageFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Future[List[Categories]] = {
      helper.livecategoriesGet(country, subcountry, hours, keywordFilter, languageFilter, lines, offset)
  }

  /**
   * Get livedata stats for domains
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param urlFilter Filter answers to domains including a specified string (optional)
   * @param hours Get results for last x hours (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Domains]
   */
  def livedomainsGet(country: String, subcountry: Option[String] = None, urlFilter: Option[String] = None, hours: Option[Integer] = None, lines: Option[Integer] = Option(50), languageFilter: Option[String] = None, offset: Option[Integer] = Option(0)): Option[List[Domains]] = {
    val await = Try(Await.result(livedomainsGetAsync(country, subcountry, urlFilter, hours, lines, languageFilter, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get livedata stats for domains asynchronously
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param subcountry state code (optional)
   * @param urlFilter Filter answers to domains including a specified string (optional)
   * @param hours Get results for last x hours (optional)
   * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Domains])
   */
  def livedomainsGetAsync(country: String, subcountry: Option[String] = None, urlFilter: Option[String] = None, hours: Option[Integer] = None, lines: Option[Integer] = Option(50), languageFilter: Option[String] = None, offset: Option[Integer] = Option(0)): Future[List[Domains]] = {
      helper.livedomainsGet(country, subcountry, urlFilter, hours, lines, languageFilter, offset)
  }

  /**
   * Get livedata stats for pages
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
   * @param subcountry state code (optional)
   * @param hours Get results for last x hours (optional)
   * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
   * @param domainFilter Filter answers to pages of a designated domain name (optional)
   * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
   * @param urlFilter Filter answers to pages URL including a specified string (optional)
   * @param categoryFilter Filter answers to pages of a designated category id (optional)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return List[Pages]
   */
  def livepagesGet(country: String, presetFilter: Integer, subcountry: Option[String] = None, hours: Option[Integer] = None, onlyNew: Option[Integer] = Option(0), domainFilter: Option[String] = None, keywordFilter: Option[String] = None, urlFilter: Option[String] = None, categoryFilter: Option[Integer] = None, languageFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Option[List[Pages]] = {
    val await = Try(Await.result(livepagesGetAsync(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get livedata stats for pages asynchronously
   * 
   *
   * @param country ISO_3166 country code in 2 letters 
   * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone 
   * @param subcountry state code (optional)
   * @param hours Get results for last x hours (optional)
   * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
   * @param domainFilter Filter answers to pages of a designated domain name (optional)
   * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
   * @param urlFilter Filter answers to pages URL including a specified string (optional)
   * @param categoryFilter Filter answers to pages of a designated category id (optional)
   * @param languageFilter Filter answers to pages in specific user language (optional)
   * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
   * @param offset Get paginated results from X offset (optional, default to 0)
   * @return Future(List[Pages])
   */
  def livepagesGetAsync(country: String, presetFilter: Integer, subcountry: Option[String] = None, hours: Option[Integer] = None, onlyNew: Option[Integer] = Option(0), domainFilter: Option[String] = None, keywordFilter: Option[String] = None, urlFilter: Option[String] = None, categoryFilter: Option[Integer] = None, languageFilter: Option[String] = None, lines: Option[Integer] = Option(50), offset: Option[Integer] = Option(0)): Future[List[Pages]] = {
      helper.livepagesGet(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset)
  }

}

class LiveApiAsyncHelper(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def livecategoriesGet(country: String,
    subcountry: Option[String] = None,
    hours: Option[Integer] = None,
    keywordFilter: Option[String] = None,
    languageFilter: Option[String] = None,
    lines: Option[Integer] = Option(50),
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Categories]]): Future[List[Categories]] = {
    // create path and map variables
    val path = (addFmt("/livecategories"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (country == null) throw new Exception("Missing required parameter 'country' when calling LiveApi->livecategoriesGet")

    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    hours match {
      case Some(param) => queryParams += "hours" -> param.toString
      case _ => queryParams
    }
    keywordFilter match {
      case Some(param) => queryParams += "keyword_filter" -> param.toString
      case _ => queryParams
    }
    languageFilter match {
      case Some(param) => queryParams += "language_filter" -> param.toString
      case _ => queryParams
    }
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def livedomainsGet(country: String,
    subcountry: Option[String] = None,
    urlFilter: Option[String] = None,
    hours: Option[Integer] = None,
    lines: Option[Integer] = Option(50),
    languageFilter: Option[String] = None,
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Domains]]): Future[List[Domains]] = {
    // create path and map variables
    val path = (addFmt("/livedomains"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (country == null) throw new Exception("Missing required parameter 'country' when calling LiveApi->livedomainsGet")

    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    urlFilter match {
      case Some(param) => queryParams += "url_filter" -> param.toString
      case _ => queryParams
    }
    hours match {
      case Some(param) => queryParams += "hours" -> param.toString
      case _ => queryParams
    }
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    languageFilter match {
      case Some(param) => queryParams += "language_filter" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def livepagesGet(country: String,
    presetFilter: Integer,
    subcountry: Option[String] = None,
    hours: Option[Integer] = None,
    onlyNew: Option[Integer] = Option(0),
    domainFilter: Option[String] = None,
    keywordFilter: Option[String] = None,
    urlFilter: Option[String] = None,
    categoryFilter: Option[Integer] = None,
    languageFilter: Option[String] = None,
    lines: Option[Integer] = Option(50),
    offset: Option[Integer] = Option(0)
    )(implicit reader: ClientResponseReader[List[Pages]]): Future[List[Pages]] = {
    // create path and map variables
    val path = (addFmt("/livepages"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (country == null) throw new Exception("Missing required parameter 'country' when calling LiveApi->livepagesGet")

    queryParams += "country" -> country.toString
    subcountry match {
      case Some(param) => queryParams += "subcountry" -> param.toString
      case _ => queryParams
    }
    hours match {
      case Some(param) => queryParams += "hours" -> param.toString
      case _ => queryParams
    }
    queryParams += "preset_filter" -> presetFilter.toString
    onlyNew match {
      case Some(param) => queryParams += "only_new" -> param.toString
      case _ => queryParams
    }
    domainFilter match {
      case Some(param) => queryParams += "domain_filter" -> param.toString
      case _ => queryParams
    }
    keywordFilter match {
      case Some(param) => queryParams += "keyword_filter" -> param.toString
      case _ => queryParams
    }
    urlFilter match {
      case Some(param) => queryParams += "url_filter" -> param.toString
      case _ => queryParams
    }
    categoryFilter match {
      case Some(param) => queryParams += "category_filter" -> param.toString
      case _ => queryParams
    }
    languageFilter match {
      case Some(param) => queryParams += "language_filter" -> param.toString
      case _ => queryParams
    }
    lines match {
      case Some(param) => queryParams += "lines" -> param.toString
      case _ => queryParams
    }
    offset match {
      case Some(param) => queryParams += "offset" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
