/**
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.api

import java.text.SimpleDateFormat

import io.swagger.client.model.Message
import io.swagger.client.model.TransactionInfo
import io.swagger.client.model.UserInfo
import io.swagger.client.{ApiInvoker, ApiException}

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date
import java.util.TimeZone

import scala.collection.mutable.HashMap

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

import java.net.URI

import com.wordnik.swagger.client.ClientResponseReaders.Json4sFormatsReader._
import com.wordnik.swagger.client.RequestWriters.Json4sFormatsWriter._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import scala.concurrent.duration._
import scala.util.{Failure, Success, Try}

import org.json4s._

class UserApi(
  val defBasePath: String = "https://api.discoversnoop.com",
  defApiInvoker: ApiInvoker = ApiInvoker
) {
  private lazy val dateTimeFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  private val dateFormatter = {
    val formatter = new SimpleDateFormat("yyyy-MM-dd")
    formatter.setTimeZone(TimeZone.getTimeZone("UTC"))
    formatter
  }
  implicit val formats = new org.json4s.DefaultFormats {
    override def dateFormatter = dateTimeFormatter
  }
  implicit val stringReader: ClientResponseReader[String] = ClientResponseReaders.StringReader
  implicit val unitReader: ClientResponseReader[Unit] = ClientResponseReaders.UnitReader
  implicit val jvalueReader: ClientResponseReader[JValue] = ClientResponseReaders.JValueReader
  implicit val jsonReader: ClientResponseReader[Nothing] = JsonFormatsReader
  implicit val stringWriter: RequestWriter[String] = RequestWriters.StringWriter
  implicit val jsonWriter: RequestWriter[Nothing] = JsonFormatsWriter

  var basePath: String = defBasePath
  var apiInvoker: ApiInvoker = defApiInvoker

  def addHeader(key: String, value: String): mutable.HashMap[String, String] = {
    apiInvoker.defaultHeaders += key -> value
  }

  val config: SwaggerConfig = SwaggerConfig.forUrl(new URI(defBasePath))
  val client = new RestClient(config)
  val helper = new UserApiAsyncHelper(client, config)

  /**
   * Change user&#x27;s activated countries
   * 
   *
   * @param countries json encoded string representing countries to activate 
   * @param categories json encoded string representing categories ID to activate 
   * @return List[TransactionInfo]
   */
  def userCountriesChangeGet(countries: String, categories: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userCountriesChangeGetAsync(countries, categories), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Change user&#x27;s activated countries asynchronously
   * 
   *
   * @param countries json encoded string representing countries to activate 
   * @param categories json encoded string representing categories ID to activate 
   * @return Future(List[TransactionInfo])
   */
  def userCountriesChangeGetAsync(countries: String, categories: String): Future[List[TransactionInfo]] = {
      helper.userCountriesChangeGet(countries, categories)
  }

  /**
   * Change user customer id. This function is system reserved
   * 
   *
   * @param custid new customer id for user 
   * @return List[TransactionInfo]
   */
  def userCustidChangeGet(custid: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userCustidChangeGetAsync(custid), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Change user customer id. This function is system reserved asynchronously
   * 
   *
   * @param custid new customer id for user 
   * @return Future(List[TransactionInfo])
   */
  def userCustidChangeGetAsync(custid: String): Future[List[TransactionInfo]] = {
      helper.userCustidChangeGet(custid)
  }

  /**
   * Permanently delete the user
   * 
   *
   * @return List[TransactionInfo]
   */
  def userDeleteGet(): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userDeleteGetAsync(), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Permanently delete the user asynchronously
   * 
   *
   * @return Future(List[TransactionInfo])
   */
  def userDeleteGetAsync(): Future[List[TransactionInfo]] = {
      helper.userDeleteGet()
  }

  /**
   * Change user details
   * 
   *
   * @param email new email address for user 
   * @param fname new firstname for user 
   * @param lname new lastname for user 
   * @return List[TransactionInfo]
   */
  def userDetailsChangeGet(email: String, fname: String, lname: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userDetailsChangeGetAsync(email, fname, lname), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Change user details asynchronously
   * 
   *
   * @param email new email address for user 
   * @param fname new firstname for user 
   * @param lname new lastname for user 
   * @return Future(List[TransactionInfo])
   */
  def userDetailsChangeGetAsync(email: String, fname: String, lname: String): Future[List[TransactionInfo]] = {
      helper.userDetailsChangeGet(email, fname, lname)
  }

  /**
   * Login user with his credentials
   * 
   *
   * @param email email address for user 
   * @param password password for user 
   * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
   * @return List[UserInfo]
   */
  def userLoginGet(email: String, password: String, pin: Option[Integer] = None): Option[List[UserInfo]] = {
    val await = Try(Await.result(userLoginGetAsync(email, password, pin), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Login user with his credentials asynchronously
   * 
   *
   * @param email email address for user 
   * @param password password for user 
   * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
   * @return Future(List[UserInfo])
   */
  def userLoginGetAsync(email: String, password: String, pin: Option[Integer] = None): Future[List[UserInfo]] = {
      helper.userLoginGet(email, password, pin)
  }

  /**
   * Get messages for user
   * 
   *
   * @param message ID of the requested message. 0 to get the full message list (optional)
   * @return List[Message]
   */
  def userMessagesGet(message: Option[Integer] = None): Option[List[Message]] = {
    val await = Try(Await.result(userMessagesGetAsync(message), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Get messages for user asynchronously
   * 
   *
   * @param message ID of the requested message. 0 to get the full message list (optional)
   * @return Future(List[Message])
   */
  def userMessagesGetAsync(message: Option[Integer] = None): Future[List[Message]] = {
      helper.userMessagesGet(message)
  }

  /**
   * Change user password
   * 
   *
   * @param email email address for user 
   * @param password current password for user 
   * @param newpassword new password to set up for user 
   * @return List[TransactionInfo]
   */
  def userPasswordChangeGet(email: String, password: String, newpassword: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userPasswordChangeGetAsync(email, password, newpassword), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Change user password asynchronously
   * 
   *
   * @param email email address for user 
   * @param password current password for user 
   * @param newpassword new password to set up for user 
   * @return Future(List[TransactionInfo])
   */
  def userPasswordChangeGetAsync(email: String, password: String, newpassword: String): Future[List[TransactionInfo]] = {
      helper.userPasswordChangeGet(email, password, newpassword)
  }

  /**
   * Reset user password
   * 
   *
   * @param email email address for user 
   * @return List[TransactionInfo]
   */
  def userPasswordResetGet(email: String): Option[List[TransactionInfo]] = {
    val await = Try(Await.result(userPasswordResetGetAsync(email), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Reset user password asynchronously
   * 
   *
   * @param email email address for user 
   * @return Future(List[TransactionInfo])
   */
  def userPasswordResetGetAsync(email: String): Future[List[TransactionInfo]] = {
      helper.userPasswordResetGet(email)
  }

  /**
   * Refresh user rights with his Customer ID. This function is system reserved
   * 
   *
   * @param custid Customer ID for the user 
   * @return List[UserInfo]
   */
  def userRefreshSubscriptionGet(custid: String): Option[List[UserInfo]] = {
    val await = Try(Await.result(userRefreshSubscriptionGetAsync(custid), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Refresh user rights with his Customer ID. This function is system reserved asynchronously
   * 
   *
   * @param custid Customer ID for the user 
   * @return Future(List[UserInfo])
   */
  def userRefreshSubscriptionGetAsync(custid: String): Future[List[UserInfo]] = {
      helper.userRefreshSubscriptionGet(custid)
  }

  /**
   * Login user with his credentials
   * 
   *
   * @param email email address for user 
   * @param password password for user 
   * @param fname new firstname for user 
   * @param lname new lastname for user 
   * @param referrer referrer for this user. should be urlencoded (optional)
   * @return List[UserInfo]
   */
  def userRegisterGet(email: String, password: String, fname: String, lname: String, referrer: Option[String] = None): Option[List[UserInfo]] = {
    val await = Try(Await.result(userRegisterGetAsync(email, password, fname, lname, referrer), Duration.Inf))
    await match {
      case Success(i) => Some(await.get)
      case Failure(t) => None
    }
  }

  /**
   * Login user with his credentials asynchronously
   * 
   *
   * @param email email address for user 
   * @param password password for user 
   * @param fname new firstname for user 
   * @param lname new lastname for user 
   * @param referrer referrer for this user. should be urlencoded (optional)
   * @return Future(List[UserInfo])
   */
  def userRegisterGetAsync(email: String, password: String, fname: String, lname: String, referrer: Option[String] = None): Future[List[UserInfo]] = {
      helper.userRegisterGet(email, password, fname, lname, referrer)
  }

}

class UserApiAsyncHelper(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def userCountriesChangeGet(countries: String,
    categories: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_countries_change"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (countries == null) throw new Exception("Missing required parameter 'countries' when calling UserApi->userCountriesChangeGet")

    if (categories == null) throw new Exception("Missing required parameter 'categories' when calling UserApi->userCountriesChangeGet")

    queryParams += "countries" -> countries.toString
    queryParams += "categories" -> categories.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userCustidChangeGet(custid: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_custid_change"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (custid == null) throw new Exception("Missing required parameter 'custid' when calling UserApi->userCustidChangeGet")

    queryParams += "custid" -> custid.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userDeleteGet()(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]


    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userDetailsChangeGet(email: String,
    fname: String,
    lname: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_details_change"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (email == null) throw new Exception("Missing required parameter 'email' when calling UserApi->userDetailsChangeGet")

    if (fname == null) throw new Exception("Missing required parameter 'fname' when calling UserApi->userDetailsChangeGet")

    if (lname == null) throw new Exception("Missing required parameter 'lname' when calling UserApi->userDetailsChangeGet")

    queryParams += "email" -> email.toString
    queryParams += "fname" -> fname.toString
    queryParams += "lname" -> lname.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userLoginGet(email: String,
    password: String,
    pin: Option[Integer] = None
    )(implicit reader: ClientResponseReader[List[UserInfo]]): Future[List[UserInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_login"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (email == null) throw new Exception("Missing required parameter 'email' when calling UserApi->userLoginGet")

    if (password == null) throw new Exception("Missing required parameter 'password' when calling UserApi->userLoginGet")

    queryParams += "email" -> email.toString
    queryParams += "password" -> password.toString
    pin match {
      case Some(param) => queryParams += "pin" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userMessagesGet(message: Option[Integer] = None
    )(implicit reader: ClientResponseReader[List[Message]]): Future[List[Message]] = {
    // create path and map variables
    val path = (addFmt("/user_messages"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    message match {
      case Some(param) => queryParams += "message" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userPasswordChangeGet(email: String,
    password: String,
    newpassword: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_password_change"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (email == null) throw new Exception("Missing required parameter 'email' when calling UserApi->userPasswordChangeGet")

    if (password == null) throw new Exception("Missing required parameter 'password' when calling UserApi->userPasswordChangeGet")

    if (newpassword == null) throw new Exception("Missing required parameter 'newpassword' when calling UserApi->userPasswordChangeGet")

    queryParams += "email" -> email.toString
    queryParams += "password" -> password.toString
    queryParams += "newpassword" -> newpassword.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userPasswordResetGet(email: String)(implicit reader: ClientResponseReader[List[TransactionInfo]]): Future[List[TransactionInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_password_reset"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (email == null) throw new Exception("Missing required parameter 'email' when calling UserApi->userPasswordResetGet")

    queryParams += "email" -> email.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userRefreshSubscriptionGet(custid: String)(implicit reader: ClientResponseReader[List[UserInfo]]): Future[List[UserInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_refresh_subscription"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (custid == null) throw new Exception("Missing required parameter 'custid' when calling UserApi->userRefreshSubscriptionGet")

    queryParams += "custid" -> custid.toString

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def userRegisterGet(email: String,
    password: String,
    fname: String,
    lname: String,
    referrer: Option[String] = None
    )(implicit reader: ClientResponseReader[List[UserInfo]]): Future[List[UserInfo]] = {
    // create path and map variables
    val path = (addFmt("/user_register"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (email == null) throw new Exception("Missing required parameter 'email' when calling UserApi->userRegisterGet")

    if (password == null) throw new Exception("Missing required parameter 'password' when calling UserApi->userRegisterGet")

    if (fname == null) throw new Exception("Missing required parameter 'fname' when calling UserApi->userRegisterGet")

    if (lname == null) throw new Exception("Missing required parameter 'lname' when calling UserApi->userRegisterGet")

    queryParams += "email" -> email.toString
    queryParams += "password" -> password.toString
    queryParams += "fname" -> fname.toString
    queryParams += "lname" -> lname.toString
    referrer match {
      case Some(param) => queryParams += "referrer" -> param.toString
      case _ => queryParams
    }

    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
